// cidrCalc_settings.js
// Copyright (c) 2009 Mark Herring

var autoCopy = null;

function $(strName){

    //Return an object
	return document.getElementById(strName);
}

function readSetting(strName){

    //Read the relevant setting
    return System.Gadget.Settings.read(strName);
}

function writeSetting(strName,strValue){

    //Write the relevant setting
    return System.Gadget.Settings.write(strName,strValue);
}

function init(){

	autoCopy = document.getElementById('AutoCopy');

	var currentSetting = System.Gadget.Settings.read('autoCopy');
	autoCopy.checked = currentSetting;

    //Read in the saved settings
	$('CIDRAddress').checked = readSetting('CIDRAddress');
	$('NetworkAddress').checked = readSetting('NetworkAddress');
	$('SubnetMask').checked = readSetting('SubnetMask');
	$('InverseMask').checked = readSetting('InverseMask');
	$('SubnetSize').checked = readSetting('SubnetSize');
	$('HostRange').checked = readSetting('HostRange');
	$('BroadcastAddress').checked = readSetting('BroadcastAddress');
	$('Version').innerHTML = 'Version: ' + System.Gadget.version;
	
	//Set the event handler
	System.Gadget.onSettingsClosing = SettingsClosing;
		
	switchFields();	
}

function switchFields(){

	//enable or disable the relevant fields
	$('CIDRAddress').disabled = !(autoCopy.checked);
	$('NetworkAddress').disabled = !(autoCopy.checked);
	$('SubnetMask').disabled = !(autoCopy.checked);
	$('InverseMask').disabled = !(autoCopy.checked);
	$('SubnetSize').disabled = !(autoCopy.checked);
	$('HostRange').disabled = !(autoCopy.checked);
	$('BroadcastAddress').disabled = !(autoCopy.checked);
}

function SettingsClosing(event)
{
	if (event.closeAction == event.Action.commit) {
		writeSetting('autoCopy', autoCopy.checked);
		writeSetting('CIDRAddress', $('CIDRAddress').checked);
		writeSetting('NetworkAddress', $('NetworkAddress').checked);
		writeSetting('SubnetMask', $('SubnetMask').checked);
		writeSetting('InverseMask', $('InverseMask').checked);
		writeSetting('SubnetSize', $('SubnetSize').checked);
		writeSetting('HostRange', $('HostRange').checked);
		writeSetting('BroadcastAddress', $('BroadcastAddress').checked);
	}

	event.cancel = false;
}